#!/bin/sh
#wi-fi up. DdShurick 04.12.14 version 003
which loginroot && loginroot=loginroot || loginroot=sudo
[ `id -u` = 0 ] || exec $loginroot $0
IFACE=$(basename $(dirname /sys/class/net/*/phy80211))
[ $(pidof dhcpcd) ] && dhcpcd -k $IFACE
[ $(pidof wpa_supplicant) ] && kill $(pidof wpa_supplicant)
[ "$(cat /sys/class/net/$IFACE/operstate)" = "up" ] || ifconfig $IFACE up
sleep 2
iwlist $IFACE sc | egrep 'Address:|Channel:|Quality|Encryption key:|ESSID:' > /tmp/iwlist
export Window="<vbox>
  <text><label>Найдены сети Wi-Fi</label></text>
  <tree>
   <variable>MYESSID</variable>
   $(awk -F \: '/ESSID/ {print "<item>"$2"</item>"}' /tmp/iwlist)
  </tree>
  <button><label>Подключить</label></button>
 </vbox>"
eval $(gtkdialog -c --program "Window")

[ "$EXIT" = "Cancel" -o  "$EXIT" = "abort" ] && exit
[ "$MYESSID" ] || exit
[  "$EXIT" = "Подключить"  ] || exit
KEY=$(grep $MYESSID -B 1 /tmp/iwlist | awk '/Encryption/ {print $2}')
if [ "$KEY" = "key:on" ]; then
export Passw="<vbox>
  <text><label>Введите пароль для $MYESSID</label></text>
  <entry>
   <visible>password</visible>
   <variable>MYPASSWD</variable>
  </entry>
  <button><label>Подключить</label></button>
</vbox>"
eval $(gtkdialog -c --program "Passw") 
[ "$EXIT" = "Cancel" -o  "$EXIT" = "abort" ] && exit
[ "$MYPASSWD" ] || exit
[  "$EXIT" = "Подключить"  ] || exit
wpa_passphrase $MYESSID $MYPASSWD | grep -v '#psk' > /tmp/wpa.conf
wpa_supplicant -B -D nl80211 -i $IFACE -c /tmp/wpa.conf
#wpa_supplicant -B -D wext -i $IFACE -c /tmp/wpa.conf #для старых версий wpa_supplicant
dhcpcd $IFACE
 if [ "$?" = 0 ]; then
export Addr="<vbox>
  <text><label>Соединение с сетью ${MYESSID} установлено.Сохранить настройки для сети ${MYESSID}?</label></text>
  <button><label>Сохранить</label></button>
</vbox>"
eval $(gtkdialog -c --program "Addr") 
[ "$EXIT" = "Cancel" -o  "$EXIT" = "abort" ] && exit
[  "$EXIT" = "Сохранить"  ] || exit
MYADDR=$(grep -B 5 USSR /tmp/iwlist | awk '/Address/ {print $5}')
cp /tmp/wpa.conf /etc/network-wizard/wireless/wpa_profiles/${MYADDR}.wpa.conf
 fi
elif [ "$KEY" = "key:off" ]; then
iwconfig $IFACE essid $MYESSID key off
dhcpcd $IFACE
fi
